#!/bin/sh

#update backup script

echo $(date +%Y_%m_%d:%H:%M:%S)" START Update backup" >> /var/log/updateLog

#does backup exist?
if ! [ -d /updateBackup ]; then
	echo $(date +%Y_%m_%d:%H:%M:%S)" Update backup dont exist! Backup failed"      #>> /var/log/updateLog
	# delete revert version
	/userScripts/revertVersionScripts/revertVersionDelete.sh
	return 1
fi

#does manifest exist?
if ! [ -f /updateBackup/MANIFEST ]; then
	echo $(date +%Y_%m_%d:%H:%M:%S)" Update manifest dont exist! Backup failed"    # >> /var/log/updateLog
	/userScripts/revertVersionScripts/revertVersionDelete.sh
	return 1
fi

cd /updateBackup
#read all strings from backup manifest file
updateFailure=false;
cat MANIFEST | while read tag val1 val2;
do
    echo $(date +%Y_%m_%d:%H:%M:%S)" CMD:[$tag]  VAL1: [$val1] VAL2:[$val2] " >> /var/log/updateLog

	if [ $tag == "process" ]; then
		killall -9 $val1;
		if [ $? != 0 ]; then
			echo $(date +%Y_%m_%d:%H:%M:%S)" Failed to kill process: $val1" >> /var/log/updateLog
			updateFailure=true;
		fi
	fi
	
	if [ $tag == "file" ]; then
		if ! [ -f /updateBackup/$val1 ]; then
			echo $(date +%Y_%m_%d:%H:%M:%S)" File for change is not exist /updateBackup/$val1" >> /var/log/updateLog
			updateFailure=true;
		fi
		
		if ! [ -d $val2 ]; then 
			echo $(date +%Y_%m_%d:%H:%M:%S)" Create directory $val2$val1" >> /var/log/updateLog
			mkdir -p $val2
		fi	
		
		cp $val1 $val2
		
		if [ $? != 0 ]; then
			echo $(date +%Y_%m_%d:%H:%M:%S)" Failed to copy file $val1" >> /var/log/updateLog 
			updateFailure=true;
		fi
	fi
	
	if [ $tag == "remove" ]; then
		pathToFile=$val2$val1
		
        if ! [ -f $pathToFile ]; then
            echo $(date +%Y_%m_%d:%H:%M:%S)" File for removing is not exist $pathToFile" >> /var/log/updateLog
            updateFailure=true;
        fi
        
        #remove file
        rm $pathToFile
        
        if [ $? != 0 ]; then
            echo $(date +%Y_%m_%d:%H:%M:%S)" Failed to remove $pathToFile" >> /var/log/updateLog
            updateFailure=true;
        fi
        
        #if directory stay empty
		pathToFile=$val2
		cd $pathToFile
		filesCntInDir=$(ls -1A|wc -l);
		echo $(date +%Y_%m_%d:%H:%M:%S)" files cnt in directory = $filesCntInDir"
		cd -
		if [ $filesCntInDir == 0 ]; then
			rm -rf $pathToFile
    fi
	fi
done

echo $(date +%Y_%m_%d:%H:%M:%S)" backup made!" >  /flags/backupWas;

cd /
rm -r /updateBackup
sync
sync

#ok

# 4 delete update blocker(only 1 update on version)
/userScripts/revertVersionScripts/sqlClearUpdateBlocker.sh

# 5 delete revert version
/userScripts/revertVersionScripts/revertVersionDelete.sh

reboot
